#include "SDLV110.h"
#include <cmath>

PIDLOOP::PIDLOOP(double fKPR, double fTNR, double fTVR)
{
	this->fKPR = fKPR;
	this->fTNR = fTNR;
	this->fTVR = fTVR;
	fErrorOld = 0.0;
	fErrorInt = 0.0;
}

void PIDLOOP::Reset()
{
	fErrorOld = 0.0;
	fErrorInt = 0.0;
}

double PIDLOOP::Calc(double fError, double fDeltaT)
{
	double fErrorDot;
	if(fDeltaT > 0.0)
		fErrorDot = (fError - fErrorOld)/fDeltaT;
	else 
		fErrorDot = 0.0;

	fErrorInt += 0.5 * (fErrorOld + fError) * fDeltaT;
	
	if(fTNR != 0.0)
	{
		return fKPR * (fError + (1.0/fTNR) * fErrorInt + fTVR * fErrorDot);
	} 
	else 
	{
		return fKPR * (fError + fTVR * fErrorDot);
	}

}

