#ifndef ___ORBITER_INTERFACE_ENHANCEMENT_VESSEL2X_H_INCLUDED___
#define ___ORBITER_INTERFACE_ENHANCEMENT_VESSEL2X_H_INCLUDED___

#include "OrbiterAPI.h"
#include "VesselAPI.h"

class VESSEL2X : public VESSEL2
{
public:
	VESSEL2X(OBJHANDLE hVessel, int iFlightModel);
	virtual ~VESSEL2X();
	
	virtual bool ExecCommand(unsigned short cmd, long lParam= 0) = 0;

	virtual unsigned long GetMemorySize() const = 0;
	virtual double GetTrueMass() const = 0;

	virtual long ReadIOL(unsigned long Channel) = 0;
	virtual short ReadIOW(unsigned long Channel) = 0;

	virtual long ReadMemoryL(unsigned long addr) const = 0;
	virtual short ReadMemoryS(unsigned long addr) const = 0;
	virtual bool WriteMemoryL(unsigned long addr, long lValue) = 0;
	virtual bool WriteMemoryS(unsigned long addr, short sValue) = 0;
	virtual bool WriteIOL(unsigned long Channel, long lValue) = 0;
	virtual bool WriteIOW(unsigned long Channel, short sValue) = 0;
};

class BASICCOMPONENT
{
protected:
	VESSEL2X* pParent;
	bool fRealized;
	virtual void Realize();
	virtual void Unrealize();
public:
	BASICCOMPONENT(VESSEL2X* pVessel);
	virtual ~BASICCOMPONENT();
};


class SDLV_COMPUTER: BASICCOMPONENT
{
public:
	SDLV_COMPUTER(VESSEL2X* pVESSEL);
};

#endif